# -*- coding: utf-8 -*-

import os
import sys
import urlparse,urllib,urllib2

import xbmc
import xbmcgui
import xbmcaddon

import windowtools
from windowtools import *

import plugintools
import navigation
from item import Item

class PostersWindow(xbmcgui.WindowXML):

    def __init__(self, xml_name, fallback_path):
        plugintools.log("PostersWindow.__init__ xml_name="+xml_name+" fallback_path="+fallback_path)

        self.first_time = False
        self.parent_item = None

        self.itemlist = []

    def setParentItem(self,item):
        self.parent_item = item

    def setItemlist(self,itemlist):
        plugintools.log("PostersWindow.setItemlist")

        for item in itemlist:
            plugintools.log("PostersWindow.setItemlist item="+item.tostring())
            self.itemlist.append(item)

    def onInit( self ):
        plugintools.log("PostersWindow.onInit")

        if self.first_time == True:
            return
        
        self.first_time = True

        self.control_list = self.getControl(100)

        for item in self.itemlist:

            plugintools.log("PostersWindow.onInit title="+item.title+", icon="+item.thumbnail)

            list_item = xbmcgui.ListItem( item.title , iconImage=item.thumbnail, thumbnailImage=item.thumbnail)
            self.control_list.addItem(list_item)

        self.setFocusId(100)

    def onAction(self, action):
        plugintools.log("PostersWindow.onAction action="+windowtools.action_to_string(action))

        pos = self.control_list.getSelectedPosition()
        item = self.itemlist[pos]
        self.getControl(101).setText(item.plot)

        if action == ACTION_PARENT_DIR or action==ACTION_PREVIOUS_MENU or action==ACTION_PREVIOUS_MENU2:
            self.close()

        if action == ACTION_SELECT_ITEM or action == ACTION_MOUSE_LEFT_CLICK:

            if self.getFocusId()==100:
                pos = self.control_list.getSelectedPosition()
                item = self.itemlist[pos]

                next_items = navigation.get_next_items( item )

                # Si no hay nada, no muestra la pantalla vacía
                if len(next_items)>0:
                    next_window = navigation.get_window_for_item( item )
                    next_window.setItemlist(next_items)
                    next_window.setParentItem(item)
                    navigation.push_window(next_window)

                    next_window.doModal()
                    del next_window

            # Search
            elif self.getFocusId()==301:
                text_to_search = plugintools.keyboard_input("","Type what you want to search for")

                if text_to_search=="":
                    return

                item = Item( action="globalsearch" , view="menu" )

                next_items = navigation.get_next_items( item )

                # Si no hay nada, no muestra la pantalla vacía
                if len(next_items)>0:
                    next_window = navigation.get_window_for_item( item )
                    next_window.setItemlist(next_items)
                    next_window.setParentItem(item)
                    navigation.push_window(next_window)

                    next_window.doModal()
                    del next_window

            # Settings
            elif self.getFocusId()==302:
                plugintools.open_settings_dialog()

            # Home
            elif self.getFocusId()==303:
                navigation.go_to_home_window()

    def onFocus( self, control_id ):
        plugintools.log("PostersWindow.onFocus "+repr(control_id))

        pos = self.control_list.getSelectedPosition()
        item = self.itemlist[pos]

        if item.plot!="":
            self.getControl(101).setText(item.plot)

    def onClick( self, control_id ):
        plugintools.log("PostersWindow.onClick "+repr(control_id))
        pass

    def onControl(self, control):
        plugintools.log("PostersWindow.onClick "+repr(control))
        pass
